import FormComponent from '../../form-component';

export class TextField extends FormComponent {
  constructor(context, options) {
    super(
      context,
      context.querySelector('.text-field__input'),
      context.querySelector('.text-field__error'),
      'Text Field',
      options
    );
    super.init();
    this.initEvents();
  }

  initEvents() {
    if (this.field.type === 'date' || this.field.type === 'time') {
      this.setIsFilledIn(true);
    } else {
      this.field.addEventListener('focus', () => this.setIsFilledIn(true));
      this.field.addEventListener('blur', () => this.setIsFilledIn());
      this.field.addEventListener('input', () => {
        // Don't just call setIsFilledIn() for the case where you've removed
        // the text field value but are still focusing the text field
        this.setIsFilledIn(
          this.field.value || this.field === document.activeElement
        );
      });
    }
  }
}

export const selector = '[class^="text-field--"]';
